SystemOrganization addCategory: #'Hipay-Core'!

Object subclass: #HPCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hipay-Core'!

!HPCategory commentStamp: 'FrancoisStephany 2/7/2012 16:48' prior: 0!
Contains the ids for different categories of HIPay merchandise.
Unfortunately, there is no list of all the available categories. You can get an overview of the categories for your website by following:

https://payment.hipay.com/order/list-categories/id/[ID_WEBSITE]

See class side.!

!HPCategory class methodsFor: 'constants' stamp: 'FrancoisStephany 2/7/2012 15:25'!
artSellerOrGallery
	^241! !

!HPCategory class methodsFor: 'constants' stamp: 'FrancoisStephany 2/7/2012 15:24'!
display
	^453! !

!HPCategory class methodsFor: 'constants' stamp: 'FrancoisStephany 2/7/2012 15:24'!
erotic
	^358! !

!HPCategory class methodsFor: 'constants' stamp: 'FrancoisStephany 2/7/2012 15:24'!
framedPicture
	^4! !

!HPCategory class methodsFor: 'constants' stamp: 'FrancoisStephany 2/7/2012 15:24'!
numericalArt
	^564! !

!HPCategory class methodsFor: 'constants' stamp: 'FrancoisStephany 2/7/2012 15:24'!
painting
	^392! !

!HPCategory class methodsFor: 'constants' stamp: 'FrancoisStephany 2/7/2012 15:24'!
philately
	^597! !

!HPCategory class methodsFor: 'constants' stamp: 'FrancoisStephany 2/7/2012 15:23'!
photography
	^166! !

!HPCategory class methodsFor: 'constants' stamp: 'FrancoisStephany 2/7/2012 15:23'!
printing
	^338! !

!HPCategory class methodsFor: 'constants' stamp: 'FrancoisStephany 2/7/2012 15:23'!
sculpture
	^123! !

Object subclass: #HPEnvironment
	instanceVariableNames: 'postURL userAccountId categoryId websiteId key urlAcquital urlOk urlKo urlCancel urlLogo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hipay-Core'!

!HPEnvironment commentStamp: 'FrancoisStephany 2/7/2012 16:48' prior: 0!
HPOrderBuilder is the starting point for Hipay.
Here's an example of how to use it with Seaside:
	order := HPOrder new
		label: 'Test Order from localhost.';
		beAllAge;
		beEuro;
		yourself.
	order addItem: (HPOrderItem new
		name: 'The Seaside book';
		infos: 'This book contains all you need.';
		amount: 100;
		quantity: 3;
		categoryId: 564).
	order addItem: (HPOrderItem new
		name: 'The Moose ';
		infos: 'This book contains all you need to start with Moose.';
		amount: 25.1;
		quantity: 4;
		categoryId: 564).
		
	env := HPEnvironment new
		beTest;
		categoryId: '564';
		userAccountId: 'YOUR_ACCOUNT_ID';
		key: 'YOUR_FORM_B_SIGNING_KEY';
		websiteId: '3497';
		yourself.
	elements := env formElementsFor: order.
	
	html heading level: 1; with: 'HiPay !!'.
	html form
		action: (elements at: #url);
		with: [
			html hiddenInput 
				name: 'mode'; 
				value: (elements at: #mode).
			html hiddenInput
				name: 'website_id';
				value: (elements at: #websiteId).
			html hiddenInput
				name: 'sign';
				value: (elements at: #sign).
			html hiddenInput
				name: 'data';
				value: (elements at: #data).
				
			html submitButton.
	]!

!HPEnvironment class methodsFor: 'categories' stamp: 'FrancoisStephany 2/7/2012 15:22'!
sculpture
	^123! !

!HPEnvironment methodsFor: 'helpers' stamp: 'FrancoisStephany 1/29/2012 15:00'!
beProduction
	self postURL: 'https://payment.hipay.com/index/form/'! !

!HPEnvironment methodsFor: 'helpers' stamp: 'FrancoisStephany 1/29/2012 15:00'!
beTest
	self postURL: 'https://test-payment.hipay.com/index/form/'! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 14:45'!
categoryId
	^ categoryId! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 14:45'!
categoryId: anObject
	categoryId := anObject! !

!HPEnvironment methodsFor: 'order create' stamp: 'FrancoisStephany 2/7/2012 16:47'!
createOrder
	^HPOrder new
		userAccountId: self userAccountId;
		categoryId: self categoryId;
		urlAcquital: self urlAcquital;
		urlOk: self urlOk;
		urlKo: self urlKo;
		urlCancel: self urlCancel;
		urlLogo: self urlLogo;
		yourself.! !

!HPEnvironment methodsFor: 'private' stamp: 'FrancoisStephany 2/7/2012 16:27'!
encodeXML: anXMLDocument
	| utfString |
	utfString := GRPharoUtf8Codec new encode: anXMLDocument asString.
	^(Base64MimeConverter mimeEncode: utfString readStream multiLine: false) contents.! !

!HPEnvironment methodsFor: 'mode B form' stamp: 'FrancoisStephany 2/7/2012 16:50'!
formElementsFor: anHPOrder
	"returns a dictionary containing all the information to use with an Hipay form."
	| elements encodedData |
	encodedData := self encodeXML: anHPOrder generateXML.
	
	^Dictionary new
		at: #websiteId put: self websiteId;
		at: #mode put: 'MODE_B';
		at: #data put: encodedData;
		at: #sign put: (MD5 hashMessage: (encodedData , self key)) hex;
		at: #url put: self postURL;
		yourself.! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 14:42'!
key
	^ key! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 14:42'!
key: anObject
	key := anObject! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 14:42'!
postURL
	^ postURL! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 14:42'!
postURL: anObject
	postURL := anObject! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 2/7/2012 20:21'!
urlAcquital
	^ urlAcquital! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 2/7/2012 20:21'!
urlAcquital: anObject
	urlAcquital := anObject! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 2/7/2012 20:21'!
urlCancel
	^ urlCancel! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 2/7/2012 20:21'!
urlCancel: anObject
	urlCancel := anObject! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 2/7/2012 20:21'!
urlKo
	^ urlKo! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 2/7/2012 20:21'!
urlKo: anObject
	urlKo := anObject! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 2/7/2012 20:21'!
urlLogo
	^ urlLogo! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 2/7/2012 20:21'!
urlLogo: anObject
	urlLogo := anObject! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 2/7/2012 20:21'!
urlOk
	^ urlOk! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 2/7/2012 20:21'!
urlOk: anObject
	urlOk := anObject! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 14:42'!
userAccountId
	^ userAccountId! !

!HPEnvironment methodsFor: 'user credentials' stamp: 'FrancoisStephany 1/29/2012 14:42'!
userAccountId: anObject
	userAccountId := anObject! !

!HPEnvironment methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 15:06'!
websiteId
	^ websiteId! !

!HPEnvironment methodsFor: 'user credentials' stamp: 'FrancoisStephany 1/29/2012 15:06'!
websiteId: anObject
	websiteId := anObject! !

Object subclass: #HPXMLSerializable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hipay-Core'!

HPXMLSerializable subclass: #HPOrder
	instanceVariableNames: 'items userAccountId currency label ageGroup categoryId urlAcquital urlOk urlKo urlCancel urlInstall urlLogo locale issuerAccountLogin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hipay-Core'!

!HPOrder commentStamp: 'FrancoisStephany 3/5/2012 13:09' prior: 0!
You should not create an istance of HPOrder directly unless you want to have total control over it.
The recommended way is to create it from an HPEnvironment (it will prepopulate some fields).


We should decouple the public interface from the implementation (and especially the XML generation)!

!HPOrder methodsFor: 'items' stamp: 'FrancoisStephany 1/29/2012 12:40'!
addItem: anHPOrderItem
	self items add: anHPOrderItem.! !

!HPOrder methodsFor: 'items' stamp: 'FrancoisStephany 2/2/2012 00:25'!
addItems: anHPOrderItemCollection
	self items addAll: anHPOrderItemCollection.! !

!HPOrder methodsFor: 'xml generation' stamp: 'FrancoisStephany 1/29/2012 13:27'!
addItemsOn: root
	| itemsNode |
	self items isEmpty ifTrue: [ ^self ].
	itemsNode := XMLElement named: 'items'.
	
	self items doWithIndex: [:each :index |
		itemsNode addElement: (each generateXMLElementWithId: index)].
	
	root addElement: itemsNode.! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 14:05'!
ageGroup
	<collectForXML>
	^ ageGroup! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
ageGroup: anObject
	ageGroup := anObject! !

!HPOrder methodsFor: 'helpers' stamp: 'FrancoisStephany 1/29/2012 14:55'!
beAllAge
	self ageGroup: 'ALL'! !

!HPOrder methodsFor: 'helpers languages' stamp: 'FrancoisStephany 1/29/2012 14:58'!
beBelgianDutch
	self locale: 'nl_BE'! !

!HPOrder methodsFor: 'helpers languages' stamp: 'FrancoisStephany 1/29/2012 14:58'!
beBelgianFrench
	self locale: 'fr_BE'! !

!HPOrder methodsFor: 'helpers' stamp: 'FrancoisStephany 1/29/2012 14:54'!
beEuro
	self currency: 'EUR'! !

!HPOrder methodsFor: 'helpers languages' stamp: 'FrancoisStephany 1/29/2012 14:58'!
beFranceFrench
	self locale: 'fr_FR'! !

!HPOrder methodsFor: 'helpers languages' stamp: 'FrancoisStephany 1/29/2012 14:58'!
beUKEnglish
	self locale: 'en_GB'! !

!HPOrder methodsFor: 'helpers languages' stamp: 'FrancoisStephany 1/29/2012 14:58'!
beUSEnglish
	self locale: 'en_US'! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 14:05'!
categoryId
	<collectForXML>
	^ categoryId! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
categoryId: anObject
	categoryId := anObject! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 14:05'!
currency
	<collectForXML>
	^ currency! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
currency: anObject
	currency := anObject! !

!HPOrder methodsFor: 'xml generation' stamp: 'FrancoisStephany 1/29/2012 13:54'!
generateXML
	| document root |
	document := XMLDocument new
		version: '1.0';
		encoding: 'UTF-8';
		yourself.
	root := XMLElement named: 'order'.
	
	self addFieldsOn: root.
	self addItemsOn: root.

	document addElement: root.
	^document! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
issuerAccountLogin
	<collectForXML>
	^ issuerAccountLogin! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
issuerAccountLogin: anObject
	issuerAccountLogin := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:41'!
items
	" items in the order."
	^ items ifNil: [ items := OrderedCollection new ].! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
items: anObject
	items := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
label
	<collectForXML>
	^ label! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
label: anObject
	label := anObject! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 14:05'!
locale
	<collectForXML>
	^ locale! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
locale: anObject
	locale := anObject! !

!HPOrder methodsFor: 'accessing helpers' stamp: 'FrancoisStephany 2/2/2012 00:32'!
size
	^self items size.! !

!HPOrder methodsFor: 'accessing helpers' stamp: 'FrancoisStephany 2/27/2012 22:19'!
totalTaxes
	^(self items inject: 0 into: [:total :next | total + next totalTaxes ]) roundTo: 0.01.
	! !

!HPOrder methodsFor: 'accessing helpers' stamp: 'FrancoisStephany 2/27/2012 22:19'!
totalWithTaxes
	^self items inject: 0 into: [:total :next | total + next totalWithTaxes ]! !

!HPOrder methodsFor: 'accessing helpers' stamp: 'FrancoisStephany 2/27/2012 21:19'!
totalWithoutTaxes
	^self items inject: 0 into: [:total :next | total + next totalWithoutTaxes ]! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
urlAcquital
	<collectForXML>
	^ urlAcquital! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
urlAcquital: anObject
	urlAcquital := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
urlCancel
	<collectForXML>
	^ urlCancel! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
urlCancel: anObject
	urlCancel := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
urlInstall
	<collectForXML>
	^ urlInstall! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
urlInstall: anObject
	urlInstall := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
urlKo
	<collectForXML>
	^ urlKo! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
urlKo: anObject
	urlKo := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
urlLogo
	<collectForXML>
	^ urlLogo! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
urlLogo: anObject
	urlLogo := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:14'!
urlOk
	<collectForXML>
	^ urlOk! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
urlOk: anObject
	urlOk := anObject! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 14:05'!
userAccountId
	<collectForXML>
	^ userAccountId! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
userAccountId: anObject
	userAccountId := anObject! !

HPXMLSerializable subclass: #HPOrderItem
	instanceVariableNames: 'taxes name infos amount categoryId quantity reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hipay-Core'!

!HPOrderItem commentStamp: 'FrancoisStephany 2/15/2012 12:31' prior: 0!
taxes:	Collection of taxes. A given tax is applied to the OrderItem, whatever  is the number of items.
amount	 is the unit price of the item, not the total price (quantity * unitPrice) *without* any taxes.
	
See the test case for a complete example using belgian VAT (21%)!

!HPOrderItem methodsFor: 'taxes' stamp: 'FrancoisStephany 2/27/2012 23:11'!
addTax: aHPTax
	aHPTax orderItem: self.
	self taxes add: aHPTax.! !

!HPOrderItem methodsFor: 'xml generation' stamp: 'FrancoisStephany 2/15/2012 12:14'!
addTaxesOn: aRootNode
	| taxesNode |
	self taxes isEmpty ifTrue: [ ^self ].
	
	taxesNode := XMLElement named: 'taxes'.
	self taxes doWithIndex: [:each :index |
		taxesNode addElement: (each generateXMLElementWithId: index)].

	aRootNode addElement: taxesNode.! !

!HPOrderItem methodsFor: 'taxes' stamp: 'FrancoisStephany 3/11/2012 20:23'!
addVat: aPercentage
	"percentage comes 21 or 19.6 not 0.21 or 0.196"
	| vat |
	vat := HPPercentTax new
		orderItem: self;
		label: ('TVA ', aPercentage printString, '%');
		percentage: aPercentage.
	self addTax: vat.! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 2/15/2012 12:24'!
amount
	"unit price of the item"
	<collectForXML>
	^ amount! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:29'!
amount: anObject
	amount := anObject! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 13:25'!
categoryId
	<collectForXML>
	^ categoryId! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:29'!
categoryId: anObject
	categoryId := anObject! !

!HPOrderItem methodsFor: 'xml generation' stamp: 'FrancoisStephany 1/29/2012 16:39'!
generateXMLElementWithId: anId
	| node |
	node := XMLElement named: 'item'.
	node attributeAt: 'id' put: anId printString.
	self addFieldsOn: node.
	self addTaxesOn: node.
	^node! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 13:25'!
infos
	<collectForXML>
	^ infos! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:29'!
infos: anObject
	infos := anObject! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 13:26'!
name
	<collectForXML>
	^ name! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:29'!
name: anObject
	name := anObject! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 13:26'!
quantity
	<collectForXML>
	^ quantity! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:29'!
quantity: anObject
	quantity := anObject! !

!HPOrderItem methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:25'!
reference
	<collectForXML>
	^ reference! !

!HPOrderItem methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:29'!
reference: anObject
	reference := anObject! !

!HPOrderItem methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 14:50'!
taxes
	^taxes ifNil: [ taxes := OrderedCollection new ]! !

!HPOrderItem methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:31'!
taxes: aCollectionOfTaxes
	taxes := aCollectionOfTaxes! !

!HPOrderItem methodsFor: 'accessing' stamp: 'FrancoisStephany 2/27/2012 22:19'!
totalTaxes
	"each taxe is per unit"
	^(self taxes inject: 0 into: [:total :next | total + (next amount * self quantity)]) roundTo: 0.01.! !

!HPOrderItem methodsFor: 'accessing' stamp: 'FrancoisStephany 2/27/2012 21:17'!
totalWithTaxes
	^self totalWithoutTaxes + self totalTaxes! !

!HPOrderItem methodsFor: 'accessing' stamp: 'FrancoisStephany 2/27/2012 21:17'!
totalWithoutTaxes
	^self amount * self quantity! !

HPXMLSerializable subclass: #HPTax
	instanceVariableNames: 'orderItem label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hipay-Core'!

HPTax subclass: #HPAbsoluteTax
	instanceVariableNames: 'amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hipay-Core'!

!HPAbsoluteTax methodsFor: 'accessing' stamp: 'FrancoisStephany 3/11/2012 09:50'!
amount
	<collectForXML>
	^amount! !

!HPAbsoluteTax methodsFor: 'accessing' stamp: 'FrancoisStephany 3/11/2012 09:56'!
amount: aNumber
	amount := aNumber! !

HPTax subclass: #HPPercentTax
	instanceVariableNames: 'percentage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hipay-Core'!

!HPPercentTax methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 3/11/2012 09:57'!
amount
	<collectForXML>
	^self orderItem amount * percentage / 100! !

!HPPercentTax methodsFor: 'accessing' stamp: 'FrancoisStephany 2/27/2012 23:08'!
percentage
	^ percentage! !

!HPPercentTax methodsFor: 'accessing' stamp: 'FrancoisStephany 3/11/2012 09:40'!
percentage: aNumber
	percentage := aNumber.! !

!HPTax methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 3/11/2012 09:49'!
amount
	self subclassResponsibility.! !

!HPTax methodsFor: 'xml generation' stamp: 'FrancoisStephany 3/11/2012 09:49'!
generateXMLElementWithId: anId
	| node |
	node := XMLElement named: 'tax'.
	node attributeAt: 'id' put: anId printString.
	self addFieldsOn: node.
	^node! !

!HPTax methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 3/11/2012 09:47'!
label
	<collectForXML>
	^ label! !

!HPTax methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 3/11/2012 09:48'!
label: anObject
	label := anObject! !

!HPTax methodsFor: 'accessing' stamp: 'FrancoisStephany 3/11/2012 09:40'!
orderItem
	^orderItem! !

!HPTax methodsFor: 'accessing' stamp: 'FrancoisStephany 3/11/2012 10:00'!
orderItem: anOrderItem
	orderItem := anOrderItem! !

!HPXMLSerializable methodsFor: 'xml generation' stamp: 'FrancoisStephany 3/11/2012 20:19'!
addFieldsOn: root
	"add all the fields with the pragma 'collectForXML''"
	(Pragma allNamed: #collectForXML from: self class to: HPXMLSerializable) do: [ :each | | key value |
		key := each selector greaseString.
		value := self perform: each selector.
		value isNil ifFalse: [
			root addElement: ((XMLElement named: key) addContent: (XMLString string: value greaseString))
		]
	].! !
